#include "allegro.h"
#include "kampf.h"
#include <stdio.h>

const int RAND=100;

int main()
{ DATAFILE *data;
  FILE *level;
  int zaehler, zaehler2;
  int position=0, auswahl=1;
  int selbst[201];
  int schussd[201];
  int schussk[201];
  int dummi[201];
  allegro_init();
  install_keyboard();
  install_timer();
  install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);
  set_gfx_mode(GFX_AUTODETECT,320,200,0,0);
  clear(screen);
  data=load_datafile("KAMPF.DAT");
  set_pallete(data[PAL].dat);
  line(screen,RAND,200,RAND,0,15);
  line(screen,320-RAND,200,320-RAND,0,15);
  selbst[0]=0;
  schussd[0]=0;
  schussk[0]=0;
  dummi[0]=0;
  while(!key[KEY_ESC])
  { /* TASTEN */
    if(key[KEY_UP]) position+=5;
    if(key[KEY_DOWN]) position-=5;
    if(key[KEY_PGUP]) position+=50;
    if(key[KEY_PGDN]) position-=50;
    if(key[KEY_TAB])
    { auswahl++;
      if(auswahl>4) auswahl=1;
    }
    if(key[KEY_ENTER])
    { switch(auswahl)
      { case 1:
        { play_sample(data[KLONG].dat,255,127,1000,FALSE);
          selbst[0]++;
          if(selbst[0]>200) selbst[0]=200;
          selbst[selbst[0]]=position;
          break;
        }
        case 2:
        { play_sample(data[KLONG].dat,255,127,1000,FALSE);
          schussd[0]++;
          if(schussd[0]>200) schussd[0]=200;
          schussd[schussd[0]]=position;
          break;
        }
        case 3:
        { play_sample(data[KLONG].dat,255,127,1000,FALSE);
          schussk[0]++;
          if(schussk[0]>200) schussk[0]=200;
          schussk[schussk[0]]=position;
          break;
        }
        case 4:
        { play_sample(data[KLONG].dat,255,127,1000,FALSE);
          dummi[0]++;
          if(dummi[0]>200) dummi[0]=200;
          dummi[dummi[0]]=position;
          break;
        }
      }
    }
    if(position<0) position=0;
    if(position>10000) position=10000;
    /* LINIE WIRD GEZEIGT */
    line(screen,RAND+1,200-position/50,320-RAND-1,200-position/50,4);
    textprintf(screen,font,20,180,14,"%d",position);
    /* BILD WIRD GEZEIGT */
    switch(auswahl)
    { case 1: blit(data[FEIND1].dat,screen,0,0,20,20,15,15); break;
      case 2: blit(data[FEIND2].dat,screen,0,0,20,20,15,15); break;
      case 3: blit(data[FEIND3].dat,screen,0,0,20,20,15,15); break;
      case 4: blit(data[FEIND4].dat,screen,0,0,20,20,15,15); break;
    }
    /* ZENTRALE EINHEIT */
    clear_keybuf();
    readkey();
    /*LINIE WIRD GELSCHT */
    line(screen,RAND+1,200-position/50,320-RAND-1,200-position/50,0);
    textprintf(screen,font,20,180,0,"     ");
  }
  /* DATEI WIRD GESCHRIEBEN */
  clear(screen);
  set_gfx_mode(GFX_TEXT,640,480,0,0);
  level=fopen("LEVEL.DAT","w");
  printf("Datei wird geschrieben:\r\n");
  fprintf(level,"int levelX()\r\n{");
  for(zaehler=1;zaehler<=selbst[0];zaehler++)
  { printf("\r\nSetze Raumschiff Kamikaze auf Position %d",selbst[zaehler]);
    fprintf(level,"\r\nselbst[%d",zaehler);
    fprintf(level,"]=%d",selbst[zaehler]);
    fprintf(level,";");
  }
  for(zaehler=1;zaehler<=schussd[0];zaehler++)
  { printf("\r\nSetze Raumschiff Shooter 1 auf Position %d",schussd[zaehler]);
    fprintf(level,"\r\nschussd[%d",zaehler);
    fprintf(level,"]=%d",schussd[zaehler]);
    fprintf(level,";");
  }
  for(zaehler=1;zaehler<=schussk[0];zaehler++)
  { printf("\r\nSetze Raumschiff Shooter 2 auf Position %d",schussk[zaehler]);
    fprintf(level,"\r\nschussk[%d",zaehler);
    fprintf(level,"]=%d",schussk[zaehler]);
    fprintf(level,";");
  }
  for(zaehler=1;zaehler<=dummi[0];zaehler++)
  { printf("\r\nSetze Komet auf Position %d",dummi[zaehler]);
    fprintf(level,"\r\ndummi[%d",zaehler);
    fprintf(level,"]=%d",dummi[zaehler]);
    fprintf(level,";");
  }
  fprintf(level,"\r\n}");
  printf("\r\n\nErzeugen der Datei beendet!");
  return 0;
}
END_OF_MAIN();
