#include <stdio.h>
#include "allegro.h"
#include "kampf.h"
#include "levels.c"

#define NOMUSIC

#ifdef NOMUSIC
#define play_midi(x,y) NULL
#define stop_midi() NULL
#endif

const int MAX_ANZAHL=20;
const int KAMIKAZE=1;
const int SHOOTER=2;
const int SHOOTER2=3;
const int KOMET=4;

void bildschirm();

PALLETE farben;
DATAFILE *data;
BITMAP *raumdel, *schussdel, *temp;
BITMAP *buffer;
int farbe[13];
int raumbx, raumby,
    blautot,
    bschussx, bschussy,
    zaehler, zaehler2, zaehler3, zaehler4,
    punkte=0, level=1,
    menu;
FILE *slotfile[5];
short int slot=1,
          kaufhealth,
          kauflaser, kaufshield,
          kaufstaerke,
          schwierigkeit;
short int mkaufhealth[2],
          mkauflaser[2], mkaufshield[2],
          mkaufstaerke[2],
          mschwierigkeit[2],
          loadshield[2], loadlaser[2],
          mslot[2],
          shieldein[2],
          laserein[2];
int       mpunkte[2], mlevel[2];
int	  faktor;	

int	  int_rotate = 0;
int	  int_rotate_counter = 0;

void rotate(void);

void bildschirm(void)
{ 
  if (int_rotate)
  {
    int_rotate_counter++;
    if (int_rotate_counter>10)
    {
      int_rotate_counter=0;
      rotate();
    }
  }
  //stretch_blit(buffer,screen,0,0,320,200,0,0,320,240);
  blit(buffer,screen,0,0,0,20,320,200);
}

// Schwarze Balken...
#define getpixel(b,x,y) getpixel(b,x,y+20)

// Joystick-Funktionen fr den GP2X
void wait_joy_button(int num, int state)
{
  int pressed = 0;
  int c;
  do {
    pressed = 0;
    poll_joystick();
    for (c=0; c<joy[num].num_buttons; c++)
    {
      if (joy[num].button[c].b)
      {
	pressed = 1;
      }
    }
    rest(5);
  } while (pressed != state);
}

void readjoy()
{
  wait_joy_button(0,0);
  wait_joy_button(0,1);
}

int joypressed()
{
  static int pressed = 0;
  int ret;
  int stick,button;
  int pressed_now = 0;
  
  poll_joystick();

  for (stick = 0; stick < num_joysticks; ++stick)
  {
    for (button = 0; button < joy[stick].num_buttons; ++button)
    {
      if (joy[stick].button[button].b)
      {
	pressed_now = 1;
	break;
      }
    }
    if (pressed_now) break;
  }

  ret = (pressed_now && !pressed);
  pressed = pressed_now;
  return ret;
}

void wait_joy_axis_released()
{
  do
  {
    poll_joystick();
    rest(5);
  } while (joy[0].stick[0].axis[0].d1 || joy[0].stick[0].axis[0].d2 || joy[0].stick[0].axis[1].d1 || joy[0].stick[0].axis[1].d2);
}

int abspann(int wahl)
{ int z;
  BITMAP *credits;
  credits=create_bitmap(320,1000);
  stop_sample(data[ANTRIEB].dat);
  play_midi(data[ABSPANNMIDI].dat,TRUE);
  clear(credits);
  textout_centre(credits,data[WESTM8].dat,"Gratulation! Sie haben Kampf im All ausgespielt!",160,90,4);

  textout_centre(credits,data[WESTM8].dat,"Programmierung",160,280,14);
  textout_centre(credits,data[WESTM8].dat,"Simon Parzer",160,300,1);
  textout_centre(credits,data[WESTM8].dat,"Parzer Simon",160,310,1);

  textout_centre(credits,data[WESTM8].dat,"Grafik",160,380,14);
  textout_centre(credits,data[WESTM8].dat,"Valentin Parzer",160,400,1);
  textout_centre(credits,data[WESTM8].dat,"Parzer Valentin",160,410,1);

  textout_centre(credits,data[WESTM8].dat,"Konzept",160,480,14);
  textout_centre(credits,data[WESTM8].dat,"Simon Parzer",160,500,1);
  textout_centre(credits,data[WESTM8].dat,"Parzer Simon",160,510,1);
  textout_centre(credits,data[WESTM8].dat,"Valentin Parzer",160,520,1);
  textout_centre(credits,data[WESTM8].dat,"Parzer Valentin",160,530,1);

  textout_centre(credits,data[WESTM8].dat,"Leveldesign",160,580,14);
  textout_centre(credits,data[WESTM8].dat,"Valentin Parzer",160,600,1);
  textout_centre(credits,data[WESTM8].dat,"Parzer Valentin",160,610,1);

  textout_centre(credits,data[WESTM8].dat,"Tester",160,680,14);
  textout_centre(credits,data[WESTM8].dat,"Simon Parzer",160,700,1);
  textout_centre(credits,data[WESTM8].dat,"Parzer Simon",160,710,1);
  textout_centre(credits,data[WESTM8].dat,"Valentin Parzer",160,720,1);
  textout_centre(credits,data[WESTM8].dat,"Parzer Valentin",160,730,1);

  textout_centre(credits,data[WESTM8].dat,"Vielen Dank an die restlichen Mitwirkenden",160,800,4);

  textout_centre(credits,data[WESTM8].dat,"(c) 2002 by Blitz Software",160,900,15);

  for(z=-100;z<=1000;z++)
  { blit(credits,buffer,0,z,0,0,320,200);
    bildschirm();
    poll_joystick();
    if (!joy[0].button[5].b)
    { rest(30);
    }
    else
    { 
    }
  }

  stop_midi();

  if(wahl==1)
  { textout_centre(buffer,data[WESTM8].dat,"Uuuups! Wir haben den Endgegner vergessen!",160,90,4);
    bildschirm();
    set_volume(150,255);
    play_midi(data[EGMUSIC].dat,TRUE);
    rest(3000);
  }

  destroy_bitmap(credits);
  return 0;
}

int colorset(void)
{ farbe[0]=48;
  farbe[1]=49;
  farbe[2]=50;
  farbe[3]=51;
  farbe[4]=52;
  
  farbe[5]=63;

  farbe[6]=216;
  farbe[7]=217;
  farbe[8]=218;
  farbe[9]=219;
  farbe[10]=220;
  
  farbe[11]=16;
  farbe[12]=20;

  faktor=1;
  return 0;
}

void rotate(void)
{ int rotatecounter;
   
  for(rotatecounter=0;rotatecounter<=4;rotatecounter++)
  { farbe[rotatecounter]++;
    if(farbe[rotatecounter]>58) farbe[rotatecounter]=48;
    farben[255-rotatecounter]=farben[farbe[rotatecounter]];
  }

  farbe[5]++;
  if(farbe[5]>72) farbe[5]=64;
  farben[250]=farben[farbe[5]];

  for(rotatecounter=6;rotatecounter<=10;rotatecounter++)
  { farbe[rotatecounter]++;
    if(farbe[rotatecounter]>223) farbe[rotatecounter]=216;
    farben[253-rotatecounter]=farben[farbe[rotatecounter]];
  }
  
  
  farbe[11]+=faktor;
  if(farbe[11]>=22) faktor=-1;
  if(farbe[11]<=16) faktor=1;
  farben[240]=farben[farbe[11]];
  farbe[12]+=faktor;
  // if(farbe[12]>26) farbe[12]=20;
  farben[241]=farben[farbe[12]];
  
  set_pallete(farben);
}

int save_spielstand(void)
{ text_mode(0);
  if (level>0)
  { /* KAUFMEN */
    clear(buffer);
    menu=1;
    do
    { wait_joy_button(0,0);
      while(!joy[0].button[0].b)
      { /* GRAU */
        textout_centre(buffer,data[WESTM16].dat,"MULTIPLAY-WAFFEN KAUFEN",160,10,4);
        textout(buffer,font,"            ",0,5,14);
        textprintf(buffer,font,0,5,14,"%d",punkte);

        textprintf(buffer,data[WESTM16].dat,70,80,4,"%d",kaufstaerke);
        textprintf(buffer,data[WESTM16].dat,240,80,4,"3000");
        textout(buffer,data[WESTM16].dat,"Schusskraft",110,80,7);

        textprintf(buffer,data[WESTM16].dat,70,110,4,"%d",kaufhealth);
        textprintf(buffer,data[WESTM16].dat,240,110,4,"3000");
        textout(buffer,data[WESTM16].dat,"Verteidigung",110,110,7);

        textout(buffer,data[WESTM16].dat,"Ende",110,170,7);
        /* GELB */
        switch(menu)
        { case 1: textout(buffer,data[WESTM16].dat,"Schusskraft",110,80,14); break;
          case 2: textout(buffer,data[WESTM16].dat,"Verteidigung",110,110,14); break;
          case 3: textout(buffer,data[WESTM16].dat,"Ende",110,170,14); break;
        }
	bildschirm();
	poll_joystick();
        if(joy[0].stick[0].axis[1].d1)
        { menu--;
          if(menu<=0) menu=3;
        }
        if(joy[0].stick[0].axis[1].d2)
        { menu++;
          if(menu>=4) menu=1;
        }
	wait_joy_axis_released();
      }
      switch(menu)
      { case 1: punkte-=3000;
                if (punkte<0)
                { punkte+=3000;
                }
                else
                { kaufstaerke+=2;
                }
                break;
        case 2: punkte-=3000;
                if (punkte<0)
                { punkte+=3000;
                }
                else
                { kaufhealth+=10;
                }
                break;
      }
    }
    while (menu!=3);
  }
  switch(slot)
  { case 1: slotfile[slot-1]=fopen("slot1.dat","w");
            break;
    case 2: slotfile[slot-1]=fopen("slot2.dat","w");
            break;
    case 3: slotfile[slot-1]=fopen("slot3.dat","w");
            break;
    case 4: slotfile[slot-1]=fopen("slot4.dat","w");
            break;
    case 5: slotfile[slot-1]=fopen("slot5.dat","w");
            break;
  }
  level++;
  fwrite(&punkte,sizeof(punkte),1,slotfile[slot-1]);
  fwrite(&level,sizeof(level),1,slotfile[slot-1]);
  fwrite(&kaufstaerke,sizeof(kaufstaerke),1,slotfile[slot-1]);
  fwrite(&kaufhealth,sizeof(kaufhealth),1,slotfile[slot-1]);
  fwrite(&schwierigkeit,sizeof(schwierigkeit),1,slotfile[slot-1]);
  fwrite(&kaufshield,sizeof(kaufshield),1,slotfile[slot-1]);
  fwrite(&kauflaser,sizeof(kauflaser),1,slotfile[slot-1]);

  fclose(slotfile[slot-1]);
  level--;
  text_mode(-1);
  return 0;
}

int load_spielstand(void)
{ switch(slot)
  { case 1: slotfile[slot-1]=fopen("slot1.dat","r");
            break;
    case 2: slotfile[slot-1]=fopen("slot2.dat","r");
            break;
    case 3: slotfile[slot-1]=fopen("slot3.dat","r");
            break;
    case 4: slotfile[slot-1]=fopen("slot4.dat","r");
            break;
    case 5: slotfile[slot-1]=fopen("slot5.dat","r");
            break;
  }
  if(slotfile[slot-1]==NULL)
  { /* NEUES SPIEL */
    clear_to_color(buffer,1);
    menu=1;
    wait_joy_button(0,0);
    while(!joy[0].button[0].b)
    { /* GRAU */
      textout_centre(buffer,data[WESTM16].dat,"NEUES SPIEL",160,5,4);
      textout(buffer,data[WESTM16].dat,"Leicht",110,50,7);
      textout(buffer,data[WESTM16].dat,"Mittel",110,80,7);
      textout(buffer,data[WESTM16].dat,"Schwer",110,110,7);
      /* GELB */
      switch(menu)
      { case 1: textout(buffer,data[WESTM16].dat,"Leicht",110,50,14); break;
        case 2: textout(buffer,data[WESTM16].dat,"Mittel",110,80,14); break;
        case 3: textout(buffer,data[WESTM16].dat,"Schwer",110,110,14); break;
      }
      bildschirm();
      poll_joystick();
      if(joy[0].stick[0].axis[1].d1)
      { menu--;
        if(menu<=0) menu=3;
      }
      if(joy[0].stick[0].axis[1].d2)
      { menu++;
        if(menu>=4) menu=1;
      }
      wait_joy_axis_released();
    }
    schwierigkeit=menu;
    level=0;
    punkte=0;
    kaufhealth=50;
    kaufstaerke=10;
    kaufshield=0;
    kauflaser=0;
    save_spielstand();
    return 0;
  }

  fread(&punkte,sizeof(punkte),1,slotfile[slot-1]);
  fread(&level,sizeof(level),1,slotfile[slot-1]);
  fread(&kaufstaerke,sizeof(kaufstaerke),1,slotfile[slot-1]);
  fread(&kaufhealth,sizeof(kaufhealth),1,slotfile[slot-1]);
  fread(&schwierigkeit,sizeof(schwierigkeit),1,slotfile[slot-1]);
  fread(&kaufshield,sizeof(kaufshield),1,slotfile[slot-1]);
  fread(&kauflaser,sizeof(kauflaser),1,slotfile[slot-1]);
  fclose(slotfile[slot-1]);
  return 0;
}

void slot_loeschen(int eslot)
{ switch(eslot)
  { case 1: unlink("slot1.dat");
            break;
    case 2: unlink("slot2.dat");
            break;
    case 3: unlink("slot3.dat");
            break;
    case 4: unlink("slot4.dat");
            break;
    case 5: unlink("slot5.dat");
            break;
  }
  play_sample(data[DELSLOT].dat,255,127,1000,FALSE);
}


int single(void)
{ BITMAP *hintergrund;
  int feindx[21], feindy[21],
      feindart[21],
      fschussx[21], fschussy[21],
      feindtemp,
      anzahl=0,
      position=1,
      scroll=200,
      bummx, bummy, explode=0,
      life=50,
      egx, egy, egballgx, egballgy, egballkx[5], egballky[5],
      eghealth;
  short int tausch=1, frame=0, schuss=0, shooterl[21], eg=0,
            egball=0, egl, toterwinkelgaga;
  /* ZUFALLSGENERATOR WIRD INITIALISIERT */
  srand(time(0));
  hintergrund=create_bitmap(320,400);
  clear(buffer);
  clear(hintergrund);
  clear(raumdel);
  clear(schussdel);
  clear(screen);
  /* LAUTSTRKE */
  set_volume(150,255);
  colorset();
  if (!int_rotate) 
  { 
    //install_int(rotate,100);
    int_rotate = 1;
  }

  /* HINTERGRUND (STERNE) WIRD VORBEREITET */
  blit(data[STERNE1].dat,hintergrund,0,0,0,0,320,200);
  blit(data[STERNE1].dat,hintergrund,0,200,0,200,320,200);
  /* SLOT WIRD ABGEFRAGT */
  clear_to_color(buffer,1);
  menu=1;
  wait_joy_button(0,0);
  while(!joy[0].button[0].b)
  { /* GRAU */
    textout(buffer,data[WESTM16].dat,"SLOT",110,5,4);
    textout(buffer,data[WESTM16].dat,"Slot 1",110,50,7);
    textout(buffer,data[WESTM16].dat,"Slot 2",110,80,7);
    textout(buffer,data[WESTM16].dat,"Slot 3",110,110,7);
    textout(buffer,data[WESTM16].dat,"Slot 4",110,140,7);
    textout(buffer,data[WESTM16].dat,"Slot 5",110,170,7);
    /* GELB */
    switch(menu)
    { case 1: textout(buffer,data[WESTM16].dat,"Slot 1",110,50,14); break;
      case 2: textout(buffer,data[WESTM16].dat,"Slot 2",110,80,14); break;
      case 3: textout(buffer,data[WESTM16].dat,"Slot 3",110,110,14); break;
      case 4: textout(buffer,data[WESTM16].dat,"Slot 4",110,140,14); break;
      case 5: textout(buffer,data[WESTM16].dat,"Slot 5",110,170,14); break;
    }
    bildschirm();
    poll_joystick();
    if(joy[0].stick[0].axis[1].d1)
    { menu--;
      if(menu<=0) menu=5;
    }
    if(joy[0].stick[0].axis[1].d2)
    { menu++;
      if(menu>=6) menu=1;
    }
    if(joy[0].button[1].b)
    { 
      destroy_bitmap(hintergrund);
      return 0;
    }
    if(joy[0].button[3].b)
    { slot_loeschen(menu);
    }
    wait_joy_axis_released();
  }
  /* SPIELSTAND WIRD GELADEN */
  slot=menu;
  load_spielstand();
  if (level<=0) level=1;
  /* ANFANG VON SINGLEPLAY */
  single_anfang:;
  /* MUSIK !!! */
  play_midi(data[LEVEL].dat,TRUE);
  life=50;
  raumbx=300;
  raumby=180;
  /* LEVEL WIRD GESETZT */
  switch(level)
  { case 1: levelclear(); level1(); break;
    case 2: levelclear(); level2(); break;
    case 3: levelclear(); level3(); break;
    case 4: { abspann(1);
              levelclear();
              eg=1;
              egx=(320 - 29) / 2;
              egy=-100;
              switch(schwierigkeit)
              { case 1: eghealth=100; break;
                case 2: eghealth=200; break;
                case 3: eghealth=400; break;
              }
            }
             break;
    case 5: abspann(2);
            if (int_rotate) 
	    {
	      //remove_int(rotate);
	      int_rotate = 0;
	    }
	    destroy_bitmap(hintergrund);
            return 0;
	    break;
    default: if (int_rotate)
             {
	       //remove_int(rotate);
	       int_rotate = 0;
	     }
	     destroy_bitmap(hintergrund);
	     return 0; break;
  }
  /* ANTRIEBSGERUSCH WIRD SIMULIERT */
  play_sample(data[ANTRIEB].dat,255,127,1000,TRUE);
  while(!joy[0].button[4].b && !joy[0].button[5].b)
  { //textprintf(buffer,font,0,0,1,"%d",anzahl);
    /* ABFRAGE, OB LEVEL AUS IST, ODER EG KOMMT */
    if((!anzahl && !eg && position>10000))
    { textout_centre(buffer,data[WESTM16].dat,"MISSION ERFOLGREICH",160,80,4);
      bildschirm();
      rest(1000);
      if (level==2) kaufshield=1;
      if (level==4) kauflaser=1;
      save_spielstand();
      clear(buffer);
      textout_centre(buffer,data[WESTM16].dat,"Spiel wurde gespeichert",160,80,1);
      if (level==2)
      { textout_centre(buffer,data[WESTM8].dat,
        "Im Multiplay-Modus ist jetzt die Waffe 'Schild' verfuegbar!",160,120,4);
      }
      if (level==4)
      { textout_centre(buffer,data[WESTM8].dat,
        "Im Multiplay-Modus ist jetzt die Waffe 'Laser' verfuegbar!",160,120,4);
      }
      bildschirm();
      readjoy();
      //clear_keybuf();
      position=1;
      level++;
      goto single_anfang;
    }
    /* ABFRAGE, OB GEGNER KOMMT */
    for(zaehler=0;zaehler<=200;zaehler++)
    { if(selbst[zaehler]==position)
      { anzahl++;
        if(anzahl>MAX_ANZAHL) anzahl=MAX_ANZAHL;
        feindart[anzahl]=KAMIKAZE;
        feindx[anzahl]=rand()%102 * 3;
        feindy[anzahl]=-20;
      }
      if(schussd[zaehler]==position)
      { anzahl++;
        if(anzahl>MAX_ANZAHL) anzahl=MAX_ANZAHL;
        feindart[anzahl]=SHOOTER;
        feindx[anzahl]=-15;
        feindy[anzahl]=rand()%100;
        fschussx[anzahl]=feindx[anzahl]+7;
        fschussy[anzahl]=feindy[anzahl]+15;
      }
      if(schussk[zaehler]==position)
      { anzahl++;
        if(anzahl>MAX_ANZAHL) anzahl=MAX_ANZAHL;
        feindart[anzahl]=SHOOTER2;
        feindx[anzahl]=315;
        feindy[anzahl]=rand()%100;
        fschussx[anzahl]=feindx[anzahl]+7;
        fschussy[anzahl]=feindy[anzahl]+15;
      }
      if(dummi[zaehler]==position)
      { anzahl++;
        if(anzahl>MAX_ANZAHL) anzahl=MAX_ANZAHL;
        feindart[anzahl]=KOMET;
        feindx[anzahl]=rand()%102 * 3;
        feindy[anzahl]=-15;
      }
    }
    /* POSITION WIRD REGISTRIERT */
    position++;
    /* HINTERGRUND WIRD ANGEZEIGT */
    if(frame)
    { frame=0;
      blit(hintergrund,buffer,0,scroll,0,0,320,200);
      scroll--;
      if(scroll<=0)
      { if(tausch)
        { /* HINTERGRUND WIRD 'VERTAUSCHT' */
          blit(data[STERNE1].dat,hintergrund,0,200,0,0,320,200);
          blit(data[STERNE1].dat,hintergrund,0,0,0,200,320,200);
          scroll=200;
          tausch=0;
        }
        else
        { /* HINTERGRUND WIRD NOCHMAL 'VERTAUSCHT' */
          blit(data[STERNE1].dat,hintergrund,0,0,0,0,320,200);
          blit(data[STERNE1].dat,hintergrund,0,200,0,200,320,200);
          scroll=200;
          tausch=1;
        }
      }
    }
    else
    { frame=1;
    }
    /* LEBEN WIRD ANGEZEIGT */
    if(eg)
    { blit(data[ENERGY].dat, buffer, 50 - (eghealth / 8),0,
                                     50 - (eghealth / 8),0,eghealth/8,10);
    }
    if(!blautot)
    { blit(data[ENERGY].dat,buffer,50-life,0,320-life,0,life,10);
    }
    if(life<=0)
    { blautot=1;
      explode=1;
      life=200;
    }
    /* EXPLOSION WIRD ANGEZEIGT */
    if(blautot)
    { bummx=raumbx;
      bummy=raumby;
    }
    if(explode>0)
    { switch(explode/5)
      { case 1: blit(data[BUMM1].dat,buffer,0,0,bummx,bummy,15,15); break;
        case 2: blit(data[BUMM2].dat,buffer,0,0,bummx,bummy,15,15); break;
        case 3: blit(data[BUMM3].dat,buffer,0,0,bummx,bummy,15,15); break;
        case 4: blit(data[BUMM4].dat,buffer,0,0,bummx,bummy,15,15); break;
        case 5: blit(data[BUMM5].dat,buffer,0,0,bummx,bummy,15,15); break;
        case 6: blit(data[BUMM6].dat,buffer,0,0,bummx,bummy,15,15); break;
        case 7: blit(raumdel,buffer,0,0,bummx,bummy,15,15); break;
      }
      explode++;
      if(explode>35) explode=0;
    }
    /* PUNKTE WERDEN ANGEZEIGT */
    textprintf(buffer,font,10,10,14,"%d",punkte);
    switch(schwierigkeit)
    { case 1: textout_centre(buffer,font,"Leicht",160,10,10); break;
      case 2: textout_centre(buffer,font,"Mittel",160,10,219); break;
      case 3: textout_centre(buffer,font,"Schwer",160,10,4); break;
    }
    /* RAUMSCHIFFE UND SCHSSE WERDEN ANGEZEIGT */
    for(zaehler=1;zaehler<=anzahl;zaehler++)
    { if(feindart[zaehler]==KAMIKAZE)
      { masked_blit(data[FEIND1].dat,buffer,0,0,
                    feindx[zaehler],feindy[zaehler],15,15);
      }
      if(feindart[zaehler]==SHOOTER)
      { masked_blit(data[FEIND2].dat,buffer,0,0,
                    feindx[zaehler],feindy[zaehler],15,15);
        masked_blit(data[FSCHUSS].dat,buffer,0,0,
                    fschussx[zaehler],fschussy[zaehler],3,3);
      }
      if(feindart[zaehler]==SHOOTER2)
      { masked_blit(data[FEIND3].dat,buffer,0,0,
                    feindx[zaehler],feindy[zaehler],15,15);
        masked_blit(data[FSCHUSS].dat,buffer,0,0,
                    fschussx[zaehler],fschussy[zaehler],3,3);
      }
      if(feindart[zaehler]==KOMET)
      { masked_blit(data[FEIND4].dat,buffer,0,0,
                    feindx[zaehler],feindy[zaehler],15,15);
      }
    }
    if (eg)
    { masked_blit(data[EG].dat,buffer,0,0,egx,egy,29,31);
      if (egball==1)
      { masked_blit(data[EGBALLG].dat,buffer,0,0,egballgx,egballgy,10,10);
      }
      if (egball>1)
      { for(zaehler=0;zaehler<=4;zaehler++)
        { masked_blit(data[EGBALLK].dat,buffer,0,0,
                      egballkx[zaehler],egballky[zaehler],5,5);
        }
      }
    }
    if(schuss)
    { masked_blit(data[SCHUSSB].dat,buffer,0,0,bschussx,bschussy,3,3);
    }
    if(!blautot)
    { masked_blit(data[BLAUFV].dat,buffer,0,0,raumbx,raumby,15,15);
    }
    bildschirm();
    /* GAME OVER */
    if(blautot && !explode)
    { stop_sample(data[ANTRIEB].dat);
      textout(buffer,data[WESTM16].dat,"GAME OVER",120,90,4);
      bildschirm();
      rest(2000);
      readjoy();
      break;
    }
    /* ZENTRALER TIMER */
    rest(5);
    /* RAUMSCHIFFE UND SCHSSE WERDEN GELSCHT */
    for(zaehler=1;zaehler<=anzahl;zaehler++)
    { blit(raumdel,buffer,0,0,feindx[zaehler],feindy[zaehler],15,15);
    }
    blit(raumdel,buffer,0,0,raumbx,raumby,15,15);
    for(zaehler=1;zaehler<=anzahl;zaehler++)
    { if(feindart[zaehler]==SHOOTER || feindart[zaehler]==SHOOTER2)
      { blit(schussdel,buffer,0,0,fschussx[zaehler],fschussy[zaehler],3,3);
      }
    }
    if(eg)
    { if(egball==1)
      { blit(raumdel,buffer,0,0,egballgx,egballgy,10,10);
      }
      if(egball>1)
      { for(zaehler=0;zaehler<=4;zaehler++)
        { blit(raumdel,buffer,0,0,egballkx[zaehler],egballky[zaehler],5,5);
        }
      }
    }
    if(schuss)
    { blit(schussdel,buffer,0,0,bschussx,bschussy,3,3);
    }
    /* TASTEN */
    poll_joystick();
    if(joy[0].stick[0].axis[0].d1 && raumbx>0) raumbx--;
    if(joy[0].stick[0].axis[0].d2 && raumbx<305) raumbx++;
    if(joy[0].button[0].b && !schuss)
    { play_sample(data[SHOT].dat,255,127,1000,FALSE);
      schuss=1;
      bschussx=raumbx+6;
      bschussy=raumby;
    }
    /* SCHUSSBEWEGUNG SPIELER UND TREFFERABFRAGE */
    if(schuss)
    { bschussy-=3;
      if(bschussy<0) schuss=0;
      for(zaehler=1;zaehler<=anzahl;zaehler++)
      { for(zaehler2=-2;zaehler2<=17;zaehler2++)
        { for(zaehler3=-2;zaehler3<=17;zaehler3++)
          { if(bschussx==feindx[zaehler]+zaehler2
               && bschussy==feindy[zaehler]+zaehler3)
            { /* PUNKTESTAND WIRD NEU BERECHNET */
              switch(feindart[zaehler])
              { case 1: case 2: case 3: /* KAMIKAZE, SHOOTER, SHOOTER2 */
                             switch(schwierigkeit)
                             { case 1: punkte+=25; break;
                               case 2: punkte+=50; break;
                               case 3: punkte+=100; break;
                             }
                             break;
                case 4 /* KOMET */: switch(schwierigkeit)
                                    { case 1: punkte+=100; break;
                                      case 2: punkte+=200; break;
                                      case 3: punkte+=400; break;
                                    }
                                    break;
              }
              /* GEGNER IST GETROFFEN UND WIRD ENTFERNT */
              stop_sample(data[BUMM].dat);
              play_sample(data[BUMM].dat,255,127,1000,FALSE);
              explode=1;
              bummx=feindx[zaehler];
              bummy=feindy[zaehler];
              schuss=0;
              anzahl--;
              for(zaehler4=zaehler;zaehler4<=anzahl;zaehler4++)
              { feindx[zaehler4]=feindx[zaehler4+1];
                feindy[zaehler4]=feindy[zaehler4+1];
                feindart[zaehler4]=feindart[zaehler4+1];
                fschussx[zaehler4]=fschussx[zaehler4+1];
                fschussy[zaehler4]=fschussy[zaehler4+1];
                shooterl[zaehler4]=shooterl[zaehler4+1];
              }
            }
          }
        }
      }
      if(eg)
      { for(zaehler=-3;zaehler<=29;zaehler++)
        { for(zaehler2=-3;zaehler2<=31;zaehler2++)
          { if(bschussx==egx+zaehler && bschussy==egy+zaehler2)
            { bschussy=-1;
              play_sample(data[KLONG].dat,255,127,1000,FALSE);
              eghealth-=10;
              if(eghealth<=0)
              { switch(schwierigkeit)
                { case 1: punkte+=6000; break;
                  case 2: punkte+=12000; break;
                  case 3: punkte+=24000; break;
                }
                play_sample(data[BUMM].dat,255,127,1000,FALSE);
                blit(data[EGBUMM1].dat,buffer,0,0,egx,egy,29,31);
                bildschirm();
                rest(100);
                blit(data[EGBUMM2].dat,buffer,0,0,egx,egy,29,31);
                bildschirm();
                rest(100);
                blit(data[EGBUMM3].dat,buffer,0,0,egx,egy,29,31);
                bildschirm();
                rest(100);
                blit(data[EGBUMM4].dat,buffer,0,0,egx,egy,29,31);
                bildschirm();
                rest(100);
                blit(data[EGBUMM5].dat,buffer,0,0,egx,egy,29,31);
                bildschirm();
                rest(100);
                blit(data[EGBUMM6].dat,buffer,0,0,egx,egy,29,31);
                bildschirm();
                rest(1000);
		anzahl=0;
		position=10000;
		eg=0;
                
              }
            }
          }
        }
      }
    }
    /* TREFFERABFRAGE VON ENDGEGNER */
    if (eg)
    { for(zaehler=-5;zaehler<=15;zaehler++)
      { for(zaehler2=-5;zaehler2<=15;zaehler2++)
        { for(zaehler3=0;zaehler3<=4;zaehler3++)
          { if(egballkx[zaehler3]==raumbx+zaehler &&
               egballky[zaehler3]==raumby+zaehler2)
            { play_sample(data[BUMM].dat,255,127,1000,FALSE);
              life-=50;
            }
          }
        }
      }
    }
    /* TREFFERABFRAGE VON SHOOTER - GEGNER */
    for(zaehler=1;zaehler<=anzahl;zaehler++)
    { if(feindart[zaehler]==SHOOTER || feindart[zaehler]==SHOOTER2)
      { for(zaehler2=-3;zaehler2<=15;zaehler2++)
        { for(zaehler3=-3;zaehler3<=15;zaehler3++)
          { if(fschussx[zaehler]==raumbx+zaehler2 &&
               fschussy[zaehler]==raumby+zaehler3)
            { play_sample(data[KLONG].dat,255,127,1000,FALSE);
              fschussy[zaehler]=210;
              switch(schwierigkeit)
              { case 1: life-=5; break;
                case 2: life-=10; break;
                case 3: life-=20; break;
              }
            }
          }
        }
      }
    }
    /* SELBSTMORD */
    for(zaehler=1;zaehler<=anzahl;zaehler++)
    { if(feindart[zaehler]==KAMIKAZE)
      { if(feindy[zaehler]==raumby)
        { anzahl--;
          for(zaehler2=zaehler;zaehler2<=anzahl;zaehler2++)
          { feindart[zaehler2]=feindart[zaehler2+1];
            feindx[zaehler2]=feindx[zaehler2+1];
            feindy[zaehler2]=feindy[zaehler2+1];
            fschussx[zaehler2]=fschussx[zaehler2+1];
            fschussy[zaehler2]=fschussy[zaehler2+1];
            shooterl[zaehler2]=shooterl[zaehler2+1];
          }
        }
        if(feindx[zaehler]>raumbx) feindx[zaehler]--;
        if(feindx[zaehler]<raumbx) feindx[zaehler]++;
        if(feindy[zaehler]>raumby) feindy[zaehler]--;
        if(feindy[zaehler]<raumby) feindy[zaehler]++;
      }
    }
    /* SHOOTER 1 */
    for(zaehler=1;zaehler<=anzahl;zaehler++)
    { if(feindart[zaehler]==SHOOTER)
      { fschussy[zaehler]+=2;
        if(fschussy[zaehler]>=200)
        { play_sample(data[SHOT].dat,255,127,1000,FALSE);
          fschussy[zaehler]=feindy[zaehler]+15;
          fschussx[zaehler]=feindx[zaehler]+7;
        }
        if(shooterl[zaehler] && frame)
        { feindx[zaehler]--;
        }
        else
        { if(frame)
          { feindx[zaehler]++;
          }
        }
        if(feindx[zaehler]<=0 && shooterl[zaehler])
        { shooterl[zaehler]=0;
        }
        if(feindx[zaehler]>=305 && !shooterl[zaehler])
        { shooterl[zaehler]=1;
        }
      }
    }
    /* SHOOTER 2 */
    for(zaehler=1;zaehler<=anzahl;zaehler++)
    { if(feindart[zaehler]==SHOOTER2)
      { fschussy[zaehler]+=2;
        if(fschussy[zaehler]>=200)
        { play_sample(data[SHOT].dat,255,127,1000,FALSE);
          fschussx[zaehler]=feindx[zaehler]+7;
          fschussy[zaehler]=feindy[zaehler]+15;
        }
        if(frame)
        { if(raumbx>feindx[zaehler]) feindx[zaehler]++;
          if(raumbx<feindx[zaehler]) feindx[zaehler]--;
        }
      }
    }
    /* KOMET */
    for(zaehler=1;zaehler<=anzahl;zaehler++)
    { if(feindart[zaehler]==KOMET)
      { feindy[zaehler]+=2;
        if(feindy[zaehler]>=200)
        { anzahl--;
          for(zaehler2=zaehler;zaehler2<=anzahl;zaehler2++)
          { feindart[zaehler2]=feindart[zaehler2+1];
            feindx[zaehler2]=feindx[zaehler2+1];
            feindy[zaehler2]=feindy[zaehler2+1];
            fschussx[zaehler2]=fschussx[zaehler2+1];
            fschussy[zaehler2]=fschussy[zaehler2+1];
            shooterl[zaehler2]=shooterl[zaehler2+1];
          }
        }
      }
    }
    /* ENDGEGNER */
    if (eg)
    { if(egl)
      { egx--;
        if(egx<0)
        { egl=0;
        }
      }
      else
      { egx++;
        if(egx>(320 - 29))
        { egl=1;
        }
      }
      //textprintf(buffer,font,200,0,4,"%d",egball);
      if(egy < 0)
      { egy++;
      }
      else
      { toterwinkelgaga=rand()%30;
        if (!egball && toterwinkelgaga==1)
        { egballgx=egx+ ((29 - 10) /2);
          egballgy=egy + 31;
          egball=1;
        }
        switch(egball)
        { case 1:
          { egballgy++;
            if(egballgy>70)
            { egball=2;
            }
            break;
          }
          case 2:
          { for(zaehler=0;zaehler<=4;zaehler++)
            { egballkx[zaehler]=egballgx;
              egballky[zaehler]=egballgy;
            }
            egball=3;
            break;
          }
          case 3:
          { egballkx[0]-=2;
            egballkx[4]+=2;
            egballkx[1]--;
            egballkx[3]++;
            if ((egballkx[2] - egballkx[1]) >= 80)
            { egball=4;
            }
            break;
          }
          case 4:
          { for(zaehler=0;zaehler<=4;zaehler++)
            { egballky[zaehler]+=5;
            }
            if (egballky[0]>200)
            { egball=0;
            }
            break;
          }
        }
      }
    }
    /* TOT - ABFRAGE */
    for(zaehler=-15;zaehler<=15;zaehler++)
    { for(zaehler2=0;zaehler2<=15;zaehler2++)
      { for(zaehler3=1;zaehler3<=anzahl;zaehler3++)
        { if(feindx[zaehler3]+zaehler==raumbx &&
             feindy[zaehler3]+zaehler2==raumby)
          { schuss=1;
            bschussx=feindx[zaehler3]+5;
            bschussy=feindy[zaehler3]+5;
            if(feindart[zaehler3]==KAMIKAZE)
            { switch(schwierigkeit)
              { case 1: life-=10; break;
                case 2: life-=20; break;
                case 3: life-=40; break;
              }
            }
            if(feindart[zaehler3]==KOMET)
            { switch(schwierigkeit)
              { case 1: life-=15; break;
                case 2: life-=30; break;
                case 3: life-=60; break;
              }
            }
          }
        }
      }
    }
  } /* While */
  if (int_rotate)
  {
    //remove_int(rotate);
    int_rotate = 0;
  }
  destroy_bitmap(hintergrund);
  return 0;
}

int mload(int spieler)
{ switch(mslot[spieler])
  { case 1: slotfile[mslot[spieler]-1]=fopen("slot1.dat","r");
            break;
    case 2: slotfile[mslot[spieler]-1]=fopen("slot2.dat","r");
            break;
    case 3: slotfile[mslot[spieler]-1]=fopen("slot3.dat","r");
            break;
    case 4: slotfile[mslot[spieler]-1]=fopen("slot4.dat","r");
            break;
    case 5: slotfile[mslot[spieler]-1]=fopen("slot5.dat","r");
            break;
  }
  if (slotfile[mslot[spieler]-1]==NULL) return 1;

  fread(&mpunkte[spieler],sizeof(mpunkte[spieler]),1,slotfile[mslot[spieler]-1]);
  fread(&mlevel[spieler],sizeof(mlevel[spieler]),1,slotfile[mslot[spieler]-1]);
  fread(&mkaufstaerke[spieler],sizeof(mkaufstaerke[spieler]),1,slotfile[mslot[spieler]-1]);
  fread(&mkaufhealth[spieler],sizeof(mkaufhealth[spieler]),1,slotfile[mslot[spieler]-1]);
  fread(&mschwierigkeit[spieler],sizeof(mschwierigkeit[spieler]),1,slotfile[mslot[spieler]-1]);
  fread(&mkaufshield[spieler],sizeof(mkaufshield[spieler]),1,slotfile[mslot[spieler]-1]);
  fread(&mkauflaser[spieler],sizeof(mkauflaser[spieler]),1,slotfile[mslot[spieler]-1]);

  fclose(slotfile[mslot[spieler]-1]);
  return 0;
}

int msave(int spieler)
{ switch(mslot[spieler])
  { case 1: slotfile[mslot[spieler]-1]=fopen("slot1.dat","w");
            break;
    case 2: slotfile[mslot[spieler]-1]=fopen("slot2.dat","w");
            break;
    case 3: slotfile[mslot[spieler]-1]=fopen("slot3.dat","w");
            break;
    case 4: slotfile[mslot[spieler]-1]=fopen("slot4.dat","w");
            break;
    case 5: slotfile[mslot[spieler]-1]=fopen("slot5.dat","w");
            break;
  }

  fwrite(&mpunkte[spieler],sizeof(mpunkte[spieler]),1,slotfile[mslot[spieler]-1]);
  fwrite(&mlevel[spieler],sizeof(mlevel[spieler]),1,slotfile[mslot[spieler]-1]);
  fwrite(&mkaufstaerke[spieler],sizeof(mkaufstaerke[spieler]),1,slotfile[mslot[spieler]-1]);
  fwrite(&mkaufhealth[spieler],sizeof(mkaufhealth[spieler]),1,slotfile[mslot[spieler]-1]);
  fwrite(&mschwierigkeit[spieler],sizeof(mschwierigkeit[spieler]),1,slotfile[mslot[spieler]-1]);
  fwrite(&mkaufshield[spieler],sizeof(mkaufshield[spieler]),1,slotfile[mslot[spieler]-1]);
  fwrite(&mkauflaser[spieler],sizeof(mkauflaser[spieler]),1,slotfile[mslot[spieler]-1]);

  fclose(slotfile[mslot[spieler]-1]);
  return 0;
}

void auftanken(void)
{ int tank;
  for(tank=0;tank<=1;tank++)
  { if (mkaufshield[tank])
    { if (shieldein[tank])
      { loadshield[tank]-=3;
        if (loadshield[tank]<=0)
        { loadshield[tank]=0;
          shieldein[tank]=0;
        }
      }
      else
      { loadshield[tank]++;
        if (loadshield[tank]>16) loadshield[tank]=16;
      }
    }
    if (mkauflaser[tank])
    { loadlaser[tank]++;
      if (loadlaser[tank]>16) loadlaser[tank]=16;
    }
  }
}

void ModusEinstellen(int modus)
{ int spielercounter;
  for (spielercounter=0;spielercounter<=1;spielercounter++)
  { switch(modus)
    { case 1: mkaufstaerke[spielercounter]=20;
              mkaufhealth[spielercounter]=20;
              mkaufshield[spielercounter]=0;
              mkauflaser[spielercounter]=0;
              break; 
      case 2: mkaufstaerke[spielercounter]=10;
              mkaufhealth[spielercounter]=50;
              mkaufshield[spielercounter]=0;
              mkauflaser[spielercounter]=0;
	      break;	
      case 3: mkaufstaerke[spielercounter]=10;
	      mkaufhealth[spielercounter]=50;
	      mkaufshield[spielercounter]=1;
	      mkauflaser[spielercounter]=1;
              break;
    }
  }
}

void quit()
{
  unload_datafile(data);
  destroy_bitmap(buffer);
  destroy_bitmap(raumdel);
  destroy_bitmap(schussdel);
  allegro_exit();
  chdir("/usr/gp2x");
  execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
}

int main()
{ int raumrx,raumry,
      richtungb,
      richtungr,
      rottot,
      blauflamme,
      rotflamme,
      rschussx, rschussy,
      richtungrsch,
      richtungbsch,
      bantrieb, rantrieb,
      rwon, bwon,
      blauhealth, rothealth,
      laserx[2], lasery[2];
  short int level;
  BITMAP *displaydel;
  FILE* log;

  log = fopen("log.txt","w");

  fprintf(log,"Program started----\n");
  fprintf(log," Initializing Allegro...\n");
  allegro_init();
  fprintf(log,"  Keyboard\n");
  install_keyboard();
  fprintf(log,"  Joystick (GP2X)\n");
  install_joystick(JOY_TYPE_AUTODETECT);
  fprintf(log,"  Timer\n");
  install_timer();
  fprintf(log,"  Video Mode (320/240)\n");
  fflush(log);
  set_gfx_mode(GFX_AUTODETECT,320,240,0,0);
  textout(screen,font,"Lade Spiel-Engine ...",5,5,1);
  rest(2000);
  textout(screen,font,"Installiere Soundtreiber ...",5,20,14);
  rest(500);
  fprintf(log,"  Sound\n");
  fflush(log);
  install_sound(MIDI_AUTODETECT,DIGI_AUTODETECT,NULL);
  textout(screen,font,"Setze Textmodus ...",5,30,14);
  rest(500);
  text_mode(-1);
  textout(screen,font,"Stelle Soundkarte ein ...",5,40,14);
  rest(500);
  set_volume(255,200);
  textout(screen,font,"Lade Daten ...",5,50,14);
  rest(500);
  fprintf(log," Loading Data...\n");
  fflush(log);
  data=load_datafile("kampf.dat");
  textout(screen,font,"Setze Palette ...",5,60,14);
  rest(500);
  fprintf(log," Loading Palette from Title Screen...\n");
  fflush(log);
  temp=load_bitmap("tbild.pcx",farben);
  textout(screen,font,"Bereite Double Buffering vor ...",5,70,14);
  rest(500);
  fprintf(log," Creating Bitmaps...\n");
  fflush(log);
  raumdel=create_bitmap(15,15);
  schussdel=create_bitmap(3,3);
  buffer=create_bitmap(320,200);
  displaydel=create_bitmap(32,30);
  textout(screen,font,"Initialisationsvorgang abgeschlossen!",5,90,14);
  textout(screen,font,"Beliebige Taste zum Starten druecken!",5,110,14);
  readjoy();
  textout(screen,font,"Jetzt noch kurz dein BIOS vernichten ...",5,130,4);
  rest(1000);
  textout(screen,font,"War nur ein Scherz, okay? ;-)",5,140,2);
  rest(1000);
  clear(screen);
  /* SCHWARZER BILDSCHIRM */
  set_pallete(black_pallete);
  /* WARTEN */
  rest(1000);
  /* MUSIK !!! */
  play_midi(data[MENUE].dat,TRUE);
  /* BITMAP */
  blit(data[TITEL].dat,buffer,0,0,0,0,320,200);
  bildschirm();
  /* EINBLENDEN */
  fade_in(data[PAL].dat,1);
  readjoy();
  /* AUSBLENDEN */
  fade_out(1);
  /* BLITZARTIG EINBLENDEN */
  set_pallete(data[PAL].dat);
  /* HAUPTMEN */
  hmenue:;
  remove_int(auftanken);
  stop_sample(data[ANTRIEB].dat);
  /* MUSIK !!! */
  play_midi(data[MENUE].dat,TRUE);
  menu=1;
  clear_to_color(buffer,1);
  wait_joy_button(0,0);
  while(!joy[0].button[0].b)
  {
    /* GRAU */
    textout(buffer,data[WESTM16].dat,"AUSWAHL",110,5,4);
    textout(buffer,data[WESTM16].dat,"Einzelspieler",110,50,7);
    textout(buffer,data[WESTM16].dat,"Mehrspieler",110,95,7);
    textout(buffer,data[WESTM16].dat,"Ende",110,140,7);
    /* GELB */
    switch(menu)
    { case 1: textout(buffer,data[WESTM16].dat,"Einzelspieler",110,50,14); break;
      case 2: textout(buffer,data[WESTM16].dat,"Mehrspieler",110,95,14); break;
      case 3: textout(buffer,data[WESTM16].dat,"Ende",110,140,14); break;
    }
    bildschirm();
    poll_joystick();
    if(joy[0].stick[0].axis[1].d1)
    { menu--;
      if(menu<=0) menu=3;
      joy[0].stick[0].axis[1].d1 = 0;
    }
    if(joy[0].stick[0].axis[1].d2)
    { menu++;
      if(menu>=4) menu=1;
      joy[0].stick[0].axis[1].d2 = 0;
    }
    wait_joy_axis_released();
  }
  switch(menu)
  { case 1: blautot=FALSE; single(); goto hmenue; break;
    case 3: 
	    destroy_bitmap(displaydel);
	    fclose(log);
	    quit();
            return 0;
            break;
  }
  /* LEVELMEN */
  menu=1;
  clear_to_color(buffer,1);
  wait_joy_button(0,0);
  while(!joy[0].button[0].b)
  { /* GRAU */
    textout(buffer,data[WESTM16].dat,"LEVELS",110,5,4);
    textout(buffer,data[WESTM16].dat,"Level 1",20,50,7);
    textout(buffer,data[WESTM16].dat,"Level 2",20,100,7);
    textout(buffer,data[WESTM16].dat,"Level 3",20,150,7);
    /* GELB */
    switch(menu)
    { case 1: textout(buffer,data[WESTM16].dat,"Level 1",20,50,14); break;
      case 2: textout(buffer,data[WESTM16].dat,"Level 2",20,100,14); break;
      case 3: textout(buffer,data[WESTM16].dat,"Level 3",20,150,14); break;
    }
    /* BILD */
    switch(menu)
    { case 1: stretch_blit(data[WELTR].dat,buffer,0,0,320,200,150,50,160,100); break;
      case 2: stretch_blit(data[WELTR2].dat,buffer,0,0,320,200,150,50,160,100); break;
      case 3: stretch_blit(data[WELTR3].dat,buffer,0,0,320,200,150,50,160,100); break;
    }
    bildschirm();
    poll_joystick();
    if(joy[0].stick[0].axis[1].d1)
    { menu--;
      if(menu<1) menu=3;
    }
    if(joy[0].stick[0].axis[1].d2)
    { menu++;
      if(menu>3) menu=1;
    }
    if(joy[0].button[1].b)
    { goto hmenue;
    }
    wait_joy_axis_released();
  }
  /* LEVEL WIRD EINGESTELLT */
  level=menu;
  /* BEGINN VON MULTIPLAY */
  rwon=0;
  bwon=0;
  clear(raumdel);
  clear(schussdel);
  clear(buffer);
  clear(displaydel);
  /* SPIELMODUS */
  menu=1;
  clear_to_color(buffer,1);
  wait_joy_button(0,0);
  while(!joy[0].button[0].b)
  { /* GRAU */
    textout(buffer,data[WESTM16].dat,"SPIELMODUS",110,5,4);
    textout(buffer,data[WESTM16].dat,"Sudden Death",100,50,7);
    textout(buffer,data[WESTM16].dat,"Normal",100,80,7);
    textout(buffer,data[WESTM16].dat,"Techno",100,110,7);
    textout(buffer,data[WESTM16].dat,"Laden",100,140,7);
    textout(buffer,data[WESTM16].dat,"Benutzer",100,170,7);
    /* GELB */
    switch(menu)
    { case 1: textout(buffer,data[WESTM16].dat,"Sudden Death",100,50,14); break;
      case 2: textout(buffer,data[WESTM16].dat,"Normal",100,80,14); break;
      case 3: textout(buffer,data[WESTM16].dat,"Techno",100,110,14); break;
      case 4: textout(buffer,data[WESTM16].dat,"Laden",100,140,14); break;
      case 5: textout(buffer,data[WESTM16].dat,"Benutzer",100,170,14); break;
    }
    bildschirm();
    poll_joystick();
    if(joy[0].stick[0].axis[1].d1)
    { menu--;
      if(menu<1) menu=5;
    }
    if(joy[0].stick[0].axis[1].d2)
    { menu++;
      if(menu>5) menu=1;
    }
    if(joy[0].button[1].b)
    { goto hmenue;
    }
    wait_joy_axis_released();
  }
  switch(menu)
  { case 4: { for(zaehler=1;zaehler<=2;zaehler++)
              { /* SLOT WIRD ABGEFRAGT */
                menu=1;
    	     	clear_to_color(buffer,1);
		wait_joy_button(0,0);
   		while(!joy[0].button[0].b && !joy[0].button[1].b)
  		  { /* GRAU */
   		   switch(zaehler)
     		   { case 1: textout(buffer,data[WESTM16].dat,"SPIELER 1",110,5,4); break;
      		     case 2: textout(buffer,data[WESTM16].dat,"SPIELER 2",110,5,4); break;
    		   }
  		   textout(buffer,data[WESTM16].dat,"Slot 1",110,50,7);
		   textout(buffer,data[WESTM16].dat,"Slot 2",110,80,7);
		   textout(buffer,data[WESTM16].dat,"Slot 3",110,110,7);
		   textout(buffer,data[WESTM16].dat,"Slot 4",110,140,7);
		   textout(buffer,data[WESTM16].dat,"Slot 5",110,170,7);
		   /* GELB */
		   switch(menu)
		   { case 1: textout(buffer,data[WESTM16].dat,"Slot 1",110,50,14); break;
		     case 2: textout(buffer,data[WESTM16].dat,"Slot 2",110,80,14); break;
		     case 3: textout(buffer,data[WESTM16].dat,"Slot 3",110,110,14); break;
		     case 4: textout(buffer,data[WESTM16].dat,"Slot 4",110,140,14); break;
		     case 5: textout(buffer,data[WESTM16].dat,"Slot 5",110,170,14); break;
		   }
		   bildschirm();
		   poll_joystick();
		   if(joy[0].stick[0].axis[1].d1)
		   { menu--;
		     if(menu<=0) menu=5;
		   }
		   if(joy[0].stick[0].axis[1].d2)
		   { menu++;
		     if(menu>=6) menu=1;
		   }
		   wait_joy_axis_released();
		 }
		 if (joy[0].button[1].b) goto hmenue;
		 mslot[zaehler-1]=menu;
		 if (mload(zaehler-1) != 0) zaehler--;
		 if ((mslot[0]==mslot[1]) && zaehler==2) zaehler--;
	       }
               break;   
             }
    case 5: { text_mode(1);
              ModusEinstellen(2);
              for(zaehler=0;zaehler<=1;zaehler++)
              { menu=1;
                clear_to_color(buffer,1);
		wait_joy_button(0,0);
	        while(!joy[0].button[0].b && !joy[0].button[1].b)
                { /* GRAU */
		  if(zaehler==0) textout(buffer,data[WESTM16].dat,"Benutzer 1",110,5,4);
		  else textout(buffer,data[WESTM16].dat,"Benutzer 2",110,5,4);
			
		  textprintf(buffer,data[WESTM16].dat,110,50,7,"Staerke:         ");
		  textprintf(buffer,data[WESTM16].dat,180,50,7,"%d",mkaufstaerke[zaehler]);
		  textprintf(buffer,data[WESTM16].dat,110,80,7,"Health:          ");
		  textprintf(buffer,data[WESTM16].dat,180,80,7,"%d",mkaufhealth[zaehler]);
	  	  textprintf(buffer,data[WESTM16].dat,110,110,7,"Schild:         ");
		  textprintf(buffer,data[WESTM16].dat,180,110,7,"%d",mkaufshield[zaehler]);
		  textprintf(buffer,data[WESTM16].dat,110,140,7,"Laser:          ");
		  textprintf(buffer,data[WESTM16].dat,180,140,7,"%d",mkauflaser[zaehler]);
		  /* GELB */
		  switch(menu)
		  { case 1: textprintf(buffer,data[WESTM16].dat,110,50,14,"Staerke:"); break;
		    case 2: textprintf(buffer,data[WESTM16].dat,110,80,14,"Health:"); break;
		    case 3: textprintf(buffer,data[WESTM16].dat,110,110,14,"Schild:"); break;	
		    case 4: textprintf(buffer,data[WESTM16].dat,110,140,14,"Laser:"); break;
		  }
		  bildschirm();
		  poll_joystick();
		  if(joy[0].stick[0].axis[1].d1)
		  { menu--;
		    if (menu<1) menu=4;
		  }
		  if(joy[0].stick[0].axis[1].d2)
		  { menu++;
		    if (menu>4) menu=1;
		  }
		  if(joy[0].stick[0].axis[0].d1)
 		  { switch(menu)
		    { case 1: mkaufstaerke[zaehler]--;
			      if(mkaufstaerke[zaehler]<1) mkaufstaerke[zaehler]=32;
			      break;
		      case 2: mkaufhealth[zaehler]--;
			      if(mkaufhealth[zaehler]<1) mkaufhealth[zaehler]=160;
			      break;
		      case 3: mkaufshield[zaehler]--;
			      if (mkaufshield[zaehler]<0) mkaufshield[zaehler]=1;
			      break;
		      case 4: mkauflaser[zaehler]--;
			      if (mkauflaser[zaehler]<0) mkauflaser[zaehler]=1;
			      break;
		    }
		  } 
		  if(joy[0].stick[0].axis[0].d2)
 		  { switch(menu)
		    { case 1: mkaufstaerke[zaehler]++;
			      if(mkaufstaerke[zaehler]>32) mkaufstaerke[zaehler]=1;
			      break;
		      case 2: mkaufhealth[zaehler]++;
			      if(mkaufhealth[zaehler]>160) mkaufhealth[zaehler]=1;
			      break;
		      case 3: mkaufshield[zaehler]++;
			      if (mkaufshield[zaehler]>1) mkaufshield[zaehler]=0;
			      break;
		      case 4: mkauflaser[zaehler]++;
			      if (mkauflaser[zaehler]>1) mkauflaser[zaehler]=0;
			      break;
		    }
		  } 
		  wait_joy_axis_released();
		} /* WHILE */
	        if(joy[0].button[1].b) goto hmenue;
	      } /* FOR */
	      text_mode(-1);
	      break;
	    } /* CASE */
    default: ModusEinstellen(menu); break;
  }
                 
  anfang:;
  //remove_int(auftanken);
  install_int(auftanken,1000);
  for(zaehler=0;zaehler<=1;zaehler++)
  { shieldein[zaehler]=0;
    laserein[zaehler]=0;
    loadshield[zaehler]=0;
    loadlaser[zaehler]=0;
  }
  blauhealth=mkaufhealth[0];
  rothealth=mkaufhealth[1];
  raumbx=20;
  raumby=20;
  raumrx=290;
  raumry=170;
  richtungrsch=0;
  richtungbsch=0;
  richtungb=1;
  richtungr=1;
  blautot=FALSE;
  rottot=FALSE;
  clear(buffer);
  switch(level)
  { case 1: blit(data[WELTR].dat,buffer,0,0,0,0,320,200); break;
    case 2: blit(data[WELTR2].dat,buffer,0,0,0,0,320,200); break;
    case 3: blit(data[WELTR3].dat,buffer,0,0,0,0,320,200); break;
  }
  bildschirm();
  play_midi(data[MUSIK].dat,TRUE);
  while(!blautot && !rottot)
  {
     /* ANZEIGE BLAU */
     /* LSCHEN */
     blit(displaydel,buffer,0,0,20,15,32,30);
     /* SCHREIBEN */
     blit(data[MANGRIFF].dat,buffer,0,0,20,15,mkaufstaerke[0]/2,3);
     blit(data[MENERGY].dat,buffer,0,0,20,20,blauhealth/5,3);
     if (loadshield[0]>=16)
     { blit(data[MLASERB].dat,buffer,0,0,20,25,16,3);
     }
     else
     { blit(data[MLASER].dat,buffer,0,0,20,25,loadshield[0],3);
     }
     if (loadlaser[0]>=16)
     { blit(data[MLASERB].dat,buffer,0,0,20,30,16,3);
     }
     else
     { blit(data[MLASER].dat,buffer,0,0,20,30,loadlaser[0],3);
     }

     /* ANZEIGE ROT */
     /* LSCHEN */
     blit(displaydel,buffer,0,0,275,165,32,30);
     /* SCHREIBEN */
     blit(data[MANGRIFF].dat,buffer,0,0,275,165,mkaufstaerke[1]/2,3);
     blit(data[MENERGY].dat,buffer,0,0,275,170,rothealth/5,3);
     if (loadshield[1]>=16)
     { blit(data[MLASERB].dat,buffer,0,0,275,175,16,3);
     }
     else
     { blit(data[MLASER].dat,buffer,0,0,275,175,loadshield[1],3);
     }
     if (loadlaser[1]>=16)
     { blit(data[MLASERB].dat,buffer,0,0,275,180,16,3);
     }
     else
     { blit(data[MLASER].dat,buffer,0,0,275,180,loadlaser[1],3);
     }

     /* RICHTUNG UND FLAMME VON BLAU */
     if(!blauflamme)
     { if(bantrieb)
         stop_sample(data[ANTRIEB].dat);
       bantrieb=0;
       switch(richtungb)
       { case 1: if (!shieldein[0])
                 { masked_blit(data[BLAUV].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 else
                 { masked_blit(data[SBLAUV].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 break;
         case 2: if (!shieldein[0])
                 { masked_blit(data[BLAUU].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 else
                 { masked_blit(data[SBLAUU].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 break;
         case 3: if (!shieldein[0])
                 { masked_blit(data[BLAUL].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 else
                 { masked_blit(data[SBLAUL].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 break;
         case 4: if (!shieldein[0])
                 { masked_blit(data[BLAUR].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 else
                 { masked_blit(data[SBLAUR].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 break;
       }
     }
     else
     { if(!bantrieb)
       { bantrieb=1;
         play_sample(data[ANTRIEB].dat,255,127,1000,TRUE);
       }
       switch(richtungb)
       {
         case 1: if (!shieldein[0])
                 { masked_blit(data[BLAUFV].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 else
                 { masked_blit(data[SBLAUFV].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 break;
         case 2: if (!shieldein[0])
                 { masked_blit(data[BLAUFU].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 else
                 { masked_blit(data[SBLAUFU].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 break;
         case 3: if (!shieldein[0])
                 { masked_blit(data[BLAUFL].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 else
                 { masked_blit(data[SBLAUFL].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 break;
         case 4: if (!shieldein[0])
                 { masked_blit(data[BLAUFR].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 else
                 { masked_blit(data[SBLAUFR].dat,buffer,0,0,raumbx,raumby,15,15);
                 }
                 break;
       }
     }
     /* SCHUSS BLAU */
     if(richtungbsch>0)
       blit(data[SCHUSSB].dat,buffer,0,0,bschussx,bschussy,3,3);
     /* SCHUSS ROT */
     if(richtungrsch>0)
       blit(data[SCHUSSR].dat,buffer,0,0,rschussx,rschussy,3,3);
     /* RICHTUNG UND FLAMME VON ROT */
     if(!rotflamme)
     { if(rantrieb)
         stop_sample(data[ANTRIEB].dat);
       rantrieb=0;
       switch(richtungr)
       { case 1: if (!shieldein[1])
                 { masked_blit(data[ROTV].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 else
                 { masked_blit(data[SROTV].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 break;
         case 2: if (!shieldein[1])
                 { masked_blit(data[ROTU].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 else
                 { masked_blit(data[SROTU].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 break;
         case 3: if (!shieldein[1])
                 { masked_blit(data[ROTL].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 else
                 { masked_blit(data[SROTL].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 break;
         case 4: if (!shieldein[1])
                 { masked_blit(data[ROTR].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 else
                 { masked_blit(data[SROTR].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 break;
       }
     }
     else
     { if(!rantrieb)
       { rantrieb=1;
         play_sample(data[ANTRIEB].dat,255,127,1000,TRUE);
       }
       switch(richtungr)
       { case 1: if (!shieldein[1])
                 { masked_blit(data[ROTFV].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 else
                 { masked_blit(data[SROTFV].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 break;
         case 2: if (!shieldein[1])
                 { masked_blit(data[ROTFU].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 else
                 { masked_blit(data[SROTFU].dat,buffer,0,0,raumrx,raumry,15,15);
                 }               
                 break;
         case 3: if (!shieldein[1])
                 { masked_blit(data[ROTFL].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 else
                 { masked_blit(data[SROTFL].dat,buffer,0,0,raumrx,raumry,15,15);
                 }               
                 break;
         case 4: if (!shieldein[1])
                 { masked_blit(data[ROTFR].dat,buffer,0,0,raumrx,raumry,15,15);
                 }
                 else
                 { masked_blit(data[SROTFR].dat,buffer,0,0,raumrx,raumry,15,15);
                 }               
                 break;
       }
     }
     bildschirm();
     /* ZENTRALER TIMER */
     rest(10);
     poll_joystick();
     /* ENDE */
     if(joy[0].button[0].b && joy[0].button[1].b && joy[0].button[2].b && joy[0].button[3].b)
     { goto hmenue;
     }
     /* BLAU LASER */
     //TODO
     if (key[KEY_RSHIFT] && loadlaser[0]>=16)
     { laserein[0]=richtungb;
       /* SOUND */
       play_sample(data[LASERWAV].dat,255,127,1000,FALSE);
       switch(laserein[0])
       { case 1: laserx[0]=raumbx+5;
                 lasery[0]=raumby-4;
       
                 for (zaehler=0;zaehler<=5;zaehler++)
                 { for (zaehler2=0;zaehler2<=3;zaehler2++)
                   { if (getpixel(screen,laserx[0]+zaehler,lasery[0]+zaehler2)==7)
                     { laserein[0]=0;
                       lasery[0]=raumby-1;
                     }
                   }
                 }
                 if (laserein[0])
                   blit(data[LASERAO].dat,buffer,0,0,laserx[0],lasery[0]+1,5,3);
                 while(laserein[0])
                 { for(zaehler=0;zaehler<=5;zaehler++)
                   { if (getpixel(screen,laserx[0]-zaehler,lasery[0])==7)
                     { laserein[0]=0;
                     }
                   }
                   if (laserx[0]>=320 || laserx[0]<=0 || lasery[0]>=200 || lasery[0]<=0)
                     laserein[0]=0;
                   for(zaehler=-4;zaehler<=15;zaehler++)
                   { for(zaehler2=0;zaehler2<=15;zaehler2++)
                     { if(laserx[0]==raumrx+zaehler &&
                          lasery[0]==raumry+zaehler2)
                       { rothealth=0;
                         rottot=1;
                       }
                     }
                   }
                   if (laserein[0])
                   { blit(data[LASEROU].dat,buffer,0,0,laserx[0],lasery[0],5,1);
                     lasery[0]--;
                   }
                }
                loadlaser[0]=0;
                bildschirm();
                rest(100);
                for(zaehler=lasery[0]+1;zaehler<=raumby+1;zaehler++)
                { blit(/*laser*/raumdel,buffer,0,0,laserx[0],zaehler,5,1);
                }
                break;
         case 2: laserx[0]=raumbx+5;
                 lasery[0]=raumby+18;
       
                 for (zaehler=0;zaehler<=5;zaehler++)
                 { for (zaehler2=-3;zaehler2<=0;zaehler2++)
                   { if (getpixel(screen,laserx[0]+zaehler,lasery[0]+zaehler2)==7)
                     { laserein[0]=0;
                       lasery[0]=raumby+15;
                     }
                   }
                 }
                 if (laserein[0])
                   blit(data[LASERAU].dat,buffer,0,0,laserx[0],lasery[0]-3,5,3);
                 while(laserein[0])
                 { for(zaehler=0;zaehler<=5;zaehler++)
                   { if (getpixel(screen,laserx[0]+zaehler,lasery[0])==7)
                     { laserein[0]=0;
                     }
                   }
                   if (laserx[0]>=320 || laserx[0]<=0 || lasery[0]>=200 || lasery[0]<=0)
                   laserein[0]=0;
                   for(zaehler=-4;zaehler<=15;zaehler++)
                   { for(zaehler2=0;zaehler2<=15;zaehler2++)
                     { if(laserx[0]==raumrx+zaehler &&
                          lasery[0]==raumry+zaehler2)
                       { rothealth=0;
                         rottot=1;
                       }
                     }
                   }
                   if (laserein[0])
                   { blit(data[LASEROU].dat,buffer,0,0,laserx[0],lasery[0],5,1);
                     lasery[0]++;
                   }
                }
                loadlaser[0]=0;
                bildschirm();
                rest(100);
                for(zaehler=lasery[0]-1;zaehler>=raumby+15;zaehler--)
                { blit(/*laser*/raumdel,buffer,0,0,laserx[0],zaehler,5,1);
                }
                break;
         case 3: laserx[0]=raumbx-3;
                 lasery[0]=raumby+5;
       
                 for (zaehler=-3;zaehler<=0;zaehler++)
                 { for (zaehler2=0;zaehler2<=5;zaehler2++)
                   { if (getpixel(screen,laserx[0]-zaehler,lasery[0]+zaehler2)==7)
                     { laserein[0]=0;
                       laserx[0]=raumbx;
                     }
                   }
                 }
                 if (laserein[0])
                   blit(data[LASERAL].dat,buffer,0,0,laserx[0],lasery[0],3,5);
                 while(laserein[0])
                 { for(zaehler=0;zaehler<=5;zaehler++)
                   { if (getpixel(screen,laserx[0],lasery[0]+zaehler)==7)
                     { laserein[0]=0;
                     }
                   }
                   if (laserx[0]>=320 || laserx[0]<=0 || lasery[0]>=200 || lasery[0]<=0)
                   laserein[0]=0;
                   for(zaehler=0;zaehler<=15;zaehler++)
                   { for(zaehler2=-4;zaehler2<=15;zaehler2++)
                     { if(laserx[0]==raumrx+zaehler &&
                          lasery[0]==raumry+zaehler2)
                       { rothealth=0;
                         rottot=1;
                       }
                     }
                   }
                   if (laserein[0])
                   { blit(data[LASERLR].dat,buffer,0,0,laserx[0],lasery[0],1,5);
                     laserx[0]--;
                   }
                }
                loadlaser[0]=0;
                bildschirm();
                rest(100);
                for(zaehler=laserx[0]+1;zaehler<=raumbx+16;zaehler++)
                { blit(/*laser*/raumdel,buffer,0,0,zaehler,lasery[0],1,5);
                }
                break;
         case 4: laserx[0]=raumbx+18;
                 lasery[0]=raumby+5;
       
                 for (zaehler=-3;zaehler<=0;zaehler++)
                 { for (zaehler2=0;zaehler2<=5;zaehler2++)
                   { if (getpixel(screen,laserx[0]+zaehler,lasery[0]+zaehler2)==7)
                     { laserein[0]=0;
                       laserx[0]=raumbx+15;
                     }
                   }
                 }
                 if (laserein[0])
                   blit(data[LASERAR].dat,buffer,0,0,laserx[0]-3,lasery[0],3,5);
                 while(laserein[0])
                 { for(zaehler=0;zaehler<=5;zaehler++)
                   { if (getpixel(screen,laserx[0],lasery[0]+zaehler)==7)
                     { laserein[0]=0;
                     }
                   }
                   if (laserx[0]>=320 || laserx[0]<=0 || lasery[0]>=200 || lasery[0]<=0)
                   laserein[0]=0;
                   for(zaehler=0;zaehler<=15;zaehler++)
                   { for(zaehler2=-4;zaehler2<=15;zaehler2++)
                     { if(laserx[0]==raumrx+zaehler &&
                          lasery[0]==raumry+zaehler2)
                       { rothealth=0;
                         rottot=1;
                       }
                     }
                   }
                   if (laserein[0])
                   { blit(data[LASERLR].dat,buffer,0,0,laserx[0],lasery[0],1,5);
                     laserx[0]++;
                   }
                }
                loadlaser[0]=0;
                bildschirm();
                rest(100);
                for(zaehler=laserx[0]-1;zaehler>=raumbx+15;zaehler--)
                { blit(/*laser*/raumdel,buffer,0,0,zaehler,lasery[0],1,5);
                }
                break;
       }
     }
     /* ROT LASER */
     //TODO
     if (key[KEY_2] && loadlaser[1]>=16)
     { laserein[1]=richtungr;
       /* SOUND */
       play_sample(data[LASERWAV].dat,255,127,1000,FALSE);
       switch(laserein[1])
       { case 1: laserx[1]=raumrx+5;
                 lasery[1]=raumry-4;
       
                 for (zaehler=0;zaehler<=5;zaehler++)
                 { for (zaehler2=0;zaehler2<=3;zaehler2++)
                   { if (getpixel(screen,laserx[1]+zaehler,lasery[1]+zaehler2)==7)
                     { laserein[1]=0;
                       lasery[1]=raumry-1;
                     }
                   }
                 }
                 if (laserein[1])
                   blit(data[LASERAO].dat,buffer,0,0,laserx[1],lasery[1]+1,5,3);
                 while(laserein[1])
                 { for(zaehler=0;zaehler<=5;zaehler++)
                   { if (getpixel(screen,laserx[1]-zaehler,lasery[1])==7)
                     { laserein[1]=0;
                     }
                   }
                   if (laserx[1]>=320 || laserx[1]<=0 || lasery[1]>=200 || lasery[1]<=0)
                     laserein[1]=0;
                   for(zaehler=-4;zaehler<=15;zaehler++)
                   { for(zaehler2=0;zaehler2<=15;zaehler2++)
                     { if(laserx[1]==raumbx+zaehler &&
                          lasery[1]==raumby+zaehler2)
                       { blauhealth=0;
                         blautot=1;
                       }
                     }
                   }
                   if (laserein[1])
                   { blit(data[LASEROU].dat,buffer,0,0,laserx[1],lasery[1],5,1);
                     lasery[1]--;
                   }
                }
                loadlaser[1]=0;
                bildschirm();
                rest(100);
                for(zaehler=lasery[1]+1;zaehler<=raumry+1;zaehler++)
                { blit(/*laser*/raumdel,buffer,0,0,laserx[1],zaehler,5,1);
                }
                break;
         case 2: laserx[1]=raumrx+5;
                 lasery[1]=raumry+18;
       
                 for (zaehler=0;zaehler<=5;zaehler++)
                 { for (zaehler2=-3;zaehler2<=0;zaehler2++)
                   { if (getpixel(screen,laserx[1]+zaehler,lasery[1]+zaehler2)==7)
                     { laserein[1]=0;
                       lasery[1]=raumry+15;
                     }
                   }
                 }
                 if (laserein[1])
                   blit(data[LASERAU].dat,buffer,0,0,laserx[1],lasery[1]-3,5,3);
                 while(laserein[1])
                 { for(zaehler=0;zaehler<=5;zaehler++)
                   { if (getpixel(screen,laserx[1]+zaehler,lasery[1])==7)
                     { laserein[1]=0;
                     }
                   }
                   if (laserx[1]>=320 || laserx[1]<=0 || lasery[1]>=200 || lasery[1]<=0)
                   laserein[1]=0;
                   for(zaehler=-4;zaehler<=15;zaehler++)
                   { for(zaehler2=0;zaehler2<=15;zaehler2++)
                     { if(laserx[1]==raumbx+zaehler &&
                          lasery[1]==raumby+zaehler2)
                       { blauhealth=0;
                         blautot=1;
                       }
                     }
                   }
                   if (laserein[1])
                   { blit(data[LASEROU].dat,buffer,0,0,laserx[1],lasery[1],5,1);
                     lasery[1]++;
                   }
                }
                loadlaser[1]=0;
                bildschirm();
                rest(100);
                for(zaehler=lasery[1]-1;zaehler>=raumry+15;zaehler--)
                { blit(/*laser*/raumdel,buffer,0,0,laserx[1],zaehler,5,1);
                }
                break;
         case 3: laserx[1]=raumrx-3;
                 lasery[1]=raumry+5;
       
                 for (zaehler=-3;zaehler<=0;zaehler++)
                 { for (zaehler2=0;zaehler2<=5;zaehler2++)
                   { if (getpixel(screen,laserx[1]-zaehler,lasery[1]+zaehler2)==7)
                     { laserein[1]=0;
                       laserx[1]=raumrx;
                     }
                   }
                 }
                 if (laserein[1])
                   blit(data[LASERAL].dat,buffer,0,0,laserx[1],lasery[1],3,5);
                 while(laserein[1])
                 { for(zaehler=0;zaehler<=5;zaehler++)
                   { if (getpixel(screen,laserx[1],lasery[1]+zaehler)==7)
                     { laserein[1]=0;
                     }
                   }
                   if (laserx[1]>=320 || laserx[1]<=0 || lasery[1]>=200 || lasery[1]<=0)
                   laserein[1]=0;
                   for(zaehler=0;zaehler<=15;zaehler++)
                   { for(zaehler2=-4;zaehler2<=15;zaehler2++)
                     { if(laserx[1]==raumbx+zaehler &&
                          lasery[1]==raumby+zaehler2)
                       { blauhealth=0;
                         blautot=1;
                       }
                     }
                   }
                   if (laserein[1])
                   { blit(data[LASERLR].dat,buffer,0,0,laserx[1],lasery[1],1,5);
                     laserx[1]--;
                   }
                }
                loadlaser[1]=0;
                bildschirm();
                rest(100);
                for(zaehler=laserx[1]+1;zaehler<=raumrx+16;zaehler++)
                { blit(/*laser*/raumdel,buffer,0,0,zaehler,lasery[1],1,5);
                }
                break;
         case 4: laserx[1]=raumrx+18;
                 lasery[1]=raumry+5;
       
                 for (zaehler=-3;zaehler<=0;zaehler++)
                 { for (zaehler2=0;zaehler2<=5;zaehler2++)
                   { if (getpixel(screen,laserx[1]+zaehler,lasery[1]+zaehler2)==7)
                     { laserein[1]=0;
                       laserx[1]=raumrx+15;
                     }
                   }
                 }
                 if (laserein[1])
                   blit(data[LASERAR].dat,buffer,0,0,laserx[1]-3,lasery[1],3,5);
                 while(laserein[1])
                 { for(zaehler=0;zaehler<=5;zaehler++)
                   { if (getpixel(screen,laserx[1],lasery[1]+zaehler)==7)
                     { laserein[1]=0;
                     }
                   }
                   if (laserx[1]>=320 || laserx[1]<=0 || lasery[1]>=200 || lasery[1]<=0)
                   laserein[1]=0;
                   for(zaehler=0;zaehler<=15;zaehler++)
                   { for(zaehler2=-4;zaehler2<=15;zaehler2++)
                     { if(laserx[1]==raumbx+zaehler &&
                          lasery[1]==raumby+zaehler2)
                       { blauhealth=0;
                         blautot=1;
                       }
                     }
                   }
                   if (laserein[1])
                   { blit(data[LASERLR].dat,buffer,0,0,laserx[1],lasery[1],1,5);
                     laserx[1]++;
                   }
                }
                loadlaser[1]=0;
                bildschirm();
                rest(100);
                for(zaehler=laserx[1]-1;zaehler>=raumrx+15;zaehler--)
                { blit(/*laser*/raumdel,buffer,0,0,zaehler,lasery[1],1,5);
                }
                break;
       }
     }
     /* BLAU WIRD GELOESCHT */
     blit(raumdel,buffer,0,0,raumbx,raumby,15,15);
     if(richtungbsch)
     { blit(schussdel,buffer,0,0,bschussx,bschussy,3,3);
     }
     /* ROT WIRD GELOESCHT */
     blit(raumdel,buffer,0,0,raumrx,raumry,15,15);
     if(richtungrsch)
     { blit(schussdel,buffer,0,0,rschussx,rschussy,3,3);
     }
     /* TASTEN BLAU */
     if(joy[0].stick[0].axis[1].d1)
     { raumby--;
       if(raumrx-raumbx>=-15 && raumrx-raumbx<=15 &&
          raumby-raumry<=15 && raumby-raumry>0)
            raumby++;
       for(zaehler=0;zaehler<=15;zaehler++)
       { if(getpixel(screen,raumbx+zaehler,raumby-1)==7)
           raumby++;
       }
       richtungb=1;
     }
     if(joy[0].stick[0].axis[1].d2)
     { raumby++;
       if(raumrx-raumbx>=-15 && raumrx-raumbx<=15 &&
          raumry-raumby<=15 && raumry-raumby>0)
            raumby--;
       for(zaehler=0;zaehler<=15;zaehler++)
       { if(getpixel(screen,raumbx+zaehler,raumby+15)==7)
           raumby--;
       }
       richtungb=2;
     }
     if(joy[0].stick[0].axis[0].d1)
     { raumbx--;
       if(raumry-raumby>=-15 && raumry-raumby<=15 &&
          raumbx-raumrx<=15 && raumbx-raumrx>0)
            raumbx++;
       for(zaehler=0;zaehler<=15;zaehler++)
       { if(getpixel(screen,raumbx-1,raumby+zaehler)==7)
            raumbx++;
       }
       richtungb=3;
     }
     if(joy[0].stick[0].axis[0].d2)
     { raumbx++;
       if(raumry-raumby>=-15 && raumry-raumby<=15 &&
          raumrx-raumbx<=15 && raumrx-raumbx>0)
            raumbx--;
       for(zaehler=0;zaehler<=15;zaehler++)
       { if(getpixel(screen,raumbx+15,raumby+zaehler)==7)
           raumbx--;
       }
       richtungb=4;
     }
     if(joy[0].button[5].b && !richtungbsch)
     { play_sample(data[SHOT].dat,220,127,1000,FALSE);
       richtungbsch=richtungb;
       switch(richtungbsch)
       { case 1: bschussx=raumbx+6;
                 bschussy=raumby-3;
                 break;
         case 2: bschussx=raumbx+6;
                 bschussy=raumby+15;
                 break;
         case 3: bschussx=raumbx-3;
                 bschussy=raumby+6;
                 break;
         case 4: bschussx=raumbx+15;
                 bschussy=raumby+6;
                 break;
       }
     }
     /* SCHILD */
     // TODO
     if (key[KEY_DEL] && !shieldein[0] && loadshield[0]>=16)
     { shieldein[0]=1;
     }
     /* SCHUSSBEWEGUNG BLAU */
     switch(richtungbsch)
     { case 1: bschussy-=3;
               for(zaehler=0;zaehler<=2;zaehler++)
               { for(zaehler2=0;zaehler2<=2;zaehler2++)
                 { if(getpixel(screen,bschussx+zaehler,bschussy+zaehler2)==7)
                     { bschussy+=3;
                       richtungbsch=0;
                     }
                 }
               }
               break;
       case 2: bschussy+=3;
               for(zaehler=0;zaehler<=2;zaehler++)
               { for(zaehler2=0;zaehler2<=2;zaehler2++)
                 { if(getpixel(screen,bschussx+zaehler,bschussy+zaehler2)==7)
                     { bschussy-=3;
                       richtungbsch=0;
                     }
                 }
               }
               break;
       case 3: bschussx-=3;
               for(zaehler=0;zaehler<=2;zaehler++)
               { for(zaehler2=0;zaehler2<=2;zaehler2++)
                 { if(getpixel(screen,bschussx+zaehler,bschussy+zaehler2)==7)
                     { bschussx+=3;
                       richtungbsch=0;
                     }
                 }
               }
               break;
       case 4: bschussx+=3;
               for(zaehler=0;zaehler<=2;zaehler++)
               { for(zaehler2=0;zaehler2<=2;zaehler2++)
                 { if(getpixel(screen,bschussx+zaehler,bschussy+zaehler2)==7)
                     { bschussx-=3;
                       richtungbsch=0;
                     }
                 }
               }
               break;
     }
         
     /* TASTEN ROT */
     if(joy[0].button[2].b)
     { raumry--;
       if(raumbx-raumrx>=-15 && raumbx-raumrx<=15 &&
          raumry-raumby<=15 && raumry-raumby>0)
            raumry++;
       for(zaehler=0;zaehler<=15;zaehler++)
       { if(getpixel(screen,raumrx+zaehler,raumry-1)==7)
           raumry++;
       }
       richtungr=1;
     }
     if(joy[0].button[1].b)
     { raumry++;
       if(raumbx-raumrx>=-15 && raumbx-raumrx<=15 &&
          raumby-raumry<=15 && raumby-raumry>0)
            raumry--;
       for(zaehler=0;zaehler<=15;zaehler++)
       { if(getpixel(screen,raumrx+zaehler,raumry+15)==7)
           raumry--;
       }
       richtungr=2;
     }
     if(joy[0].button[3].b)
     { raumrx--;
       if(raumby-raumry>=-15 && raumby-raumry<=15 &&
          raumrx-raumbx<=15 && raumrx-raumbx>0)
            raumrx++;
       for(zaehler=0;zaehler<=15;zaehler++)
       { if(getpixel(screen,raumrx-1,raumry+zaehler)==7)
            raumrx++;
       }
       richtungr=3;
     }
     if(joy[0].button[0].b)
     { raumrx++;
       if(raumby-raumry>=-15 && raumby-raumry<=15 &&
          raumbx-raumrx<=15 && raumbx-raumrx>0)
            raumrx--;
       for(zaehler=0;zaehler<=15;zaehler++)
       { if(getpixel(screen,raumrx+15,raumry+zaehler)==7)
           raumrx--;
       }
       richtungr=4;
     }
     if(joy[0].button[4].b && !richtungrsch)
     { play_sample(data[SHOT].dat,220,127,1000,FALSE);
       richtungrsch=richtungr;
       switch(richtungrsch)
       { case 1: rschussx=raumrx+6;
                 rschussy=raumry-3;
                 break;
         case 2: rschussx=raumrx+6;
                 rschussy=raumry+15;
                 break;
         case 3: rschussx=raumrx-3;
                 rschussy=raumry+6;
                 break;
         case 4: rschussx=raumrx+15;
                 rschussy=raumry+6;
                 break;
       }
     }
     /* SCHILD */
     //TODO
     if (key[KEY_1] && !shieldein[1] && loadshield[1]>=16)
     { shieldein[1]=1;
     }
     /* SCHUSSBEWEGUNG ROT */
     switch(richtungrsch)
     { case 1: rschussy-=3;
               for(zaehler=0;zaehler<=2;zaehler++)
               { for(zaehler2=0;zaehler2<=2;zaehler2++)
                 { if(getpixel(screen,rschussx+zaehler,rschussy+zaehler2)==7)
                     { rschussy+=3;
                       richtungrsch=0;
                     }
                 }
               }
               break;
       case 2: rschussy+=3;
               for(zaehler=0;zaehler<=2;zaehler++)
               { for(zaehler2=0;zaehler2<=2;zaehler2++)
                 { if(getpixel(screen,rschussx+zaehler,rschussy+zaehler2)==7)
                     { rschussy-=3;
                       richtungrsch=0;
                     }
                 }
               }
               break;
       case 3: rschussx-=3;
               for(zaehler=0;zaehler<=2;zaehler++)
               { for(zaehler2=0;zaehler2<=2;zaehler2++)
                 { if(getpixel(screen,rschussx+zaehler,rschussy+zaehler2)==7)
                     { rschussx+=3;
                       richtungrsch=0;
                     }
                 }
               }
               break;
       case 4: rschussx+=3;
               for(zaehler=0;zaehler<=2;zaehler++)
               { for(zaehler2=0;zaehler2<=2;zaehler2++)
                 { if(getpixel(screen,rschussx+zaehler,rschussy+zaehler2)==7)
                     { rschussx-=3;
                       richtungrsch=0;
                     }
                 }
               }
               break;
     }
     /* KOLLISIONSABFRAGE BLAU-ROT */
     if(richtungbsch>0)
     { for(zaehler=-3;zaehler<=16;zaehler++)
       { for(zaehler2=-3;zaehler2<=14;zaehler2++)
         { if(bschussx==raumrx+zaehler && bschussy==raumry+zaehler2)
           { if (!shieldein[1])
             { play_sample(data[KLONG].dat,255,127,1000,FALSE);
               rothealth-=mkaufstaerke[0];
               if (rothealth<=0) rottot=1;
             }
             richtungbsch=0;
           }
         }
       }
     }
     /* KOLLISIONSABFRAGE ROT-BLAU */
     if(richtungrsch>0)
     { for(zaehler=-3;zaehler<=16;zaehler++)
       { for(zaehler2=-3;zaehler2<=14;zaehler2++)
         { if(rschussx==raumbx+zaehler && rschussy==raumby+zaehler2)
           { if (!shieldein[0])
             { play_sample(data[KLONG].dat,255,127,1000,FALSE);
               blauhealth-=mkaufstaerke[1];
               if (blauhealth<=0) blautot=1;
             }
             richtungrsch=0;
           }
         }
       }
     }
     /* BLAU */
     if(raumbx<-5) raumbx=315;
     if(raumbx>315) raumbx=-5;
     if(raumby<-5) raumby=195;
     if(raumby>195) raumby=-5;
     if(bschussx<-5 || bschussx>320 || bschussy<-5 || bschussy>200)
       richtungbsch=0;
     if(!joy[0].stick[0].axis[1].d1 && !joy[0].stick[0].axis[1].d2 && !joy[0].stick[0].axis[0].d1 && !joy[0].stick[0].axis[0].d2)
        blauflamme=0;
     else blauflamme=1;
     /* ROT */
     if(raumrx<-5) raumrx=315;
     if(raumrx>315) raumrx=-5;
     if(raumry<-5) raumry=195;
     if(raumry>195) raumry=-5;
     if(rschussx<-5 || rschussx>320 || rschussy<-5 || rschussy>200)
       richtungrsch=0;
     if(!joy[0].button[2].b && !joy[0].button[1].b && !joy[0].button[3].b && !joy[0].button[0].b)
        rotflamme=0;
     else rotflamme=1;
  }
  stop_midi();
  play_sample(data[BUMM].dat,255,127,1000,FALSE);
  if(rottot)
  { bwon++;
    blit(data[BLAUV].dat,buffer,0,0,raumbx,raumby,15,15);
    blit(data[BUMM1].dat,buffer,0,0,raumrx,raumry,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM2].dat,buffer,0,0,raumrx,raumry,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM3].dat,buffer,0,0,raumrx,raumry,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM4].dat,buffer,0,0,raumrx,raumry,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM5].dat,buffer,0,0,raumrx,raumry,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM6].dat,buffer,0,0,raumrx,raumry,15,15);
    bildschirm();
    rest(50);
    blit(raumdel,buffer,0,0,raumrx,raumry,15,15);
    bildschirm();
    rest(1000);
  }
  if(blautot)
  { rwon++;
    blit(data[ROTV].dat,buffer,0,0,raumrx,raumry,15,15);
    blit(data[BUMM1].dat,buffer,0,0,raumbx,raumby,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM2].dat,buffer,0,0,raumbx,raumby,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM3].dat,buffer,0,0,raumbx,raumby,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM4].dat,buffer,0,0,raumbx,raumby,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM5].dat,buffer,0,0,raumbx,raumby,15,15);
    bildschirm();
    rest(50);
    blit(data[BUMM6].dat,buffer,0,0,raumbx,raumby,15,15);
    bildschirm();
    rest(50);
    blit(raumdel,buffer,0,0,raumbx,raumby,15,15);
    bildschirm();
    rest(1000);
  }
  clear(buffer);
  for(zaehler=0;zaehler<bwon;zaehler++)
    { blit(data[BMEDAILLE].dat,buffer,0,0,zaehler*60,30,60,60);
    }
  for(zaehler=0;zaehler<rwon;zaehler++)
    { blit(data[RMEDAILLE].dat,buffer,0,0,zaehler*60,120,60,60);
    }
  bildschirm();
  rest(1000);
  if(rwon>4)
  { blit(data[REDWON].dat,buffer,0,0,0,0,320,200);
    bildschirm();
    rest(3000);
    goto hmenue;
  }
  if(bwon>4)
  { blit(data[BLUEWON].dat,buffer,0,0,0,0,320,200);
    bildschirm();
    rest(3000);
    goto hmenue;
  }
  goto anfang;
}
END_OF_MAIN();
